package com.prolog.eis.service.out.impl;

import com.prolog.eis.dao.out.ContainerTaskHisMapper;
import com.prolog.eis.model.container.ContainerTaskHis;
import com.prolog.eis.service.out.ContainerTaskHisService;
import com.prolog.framework.core.restriction.Criteria;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author zmr
 * @description: 出库容器任务表-服务实现类
 * @date 2023-08-30 12:24
 */
@Service
public class ContainerTaskHisServiceImpl implements ContainerTaskHisService {

    @Autowired
    private ContainerTaskHisMapper containerTaskHisMapper;

    /**
     * 新增数据
     *
     * @param containerTaskHis 出库容器任务表
     */
    @Override
    public long save(ContainerTaskHis containerTaskHis) {
        return containerTaskHisMapper.save(containerTaskHis);
    }

    /**
     * 新增批量数据
     *
     * @param containerTaskHisList 出库容器任务表
     */
    @Override
    public long saveBatch(List<ContainerTaskHis> containerTaskHisList) {
        return containerTaskHisMapper.saveBatch(containerTaskHisList);
    }

    /**
     * 查询多条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<ContainerTaskHis> findByMap(Map<String, Object> paramMap) {
        return containerTaskHisMapper.findByMap(paramMap, ContainerTaskHis.class);
    }

    /**
     * 查询单条数据
     *
     * @param paramMap 查询起始位置
     * @return 对象
     */
    @Override
    public ContainerTaskHis findOneByMap(Map<String, Object> paramMap) {
        List<ContainerTaskHis> dataList = findByMap(paramMap);
        if(dataList.isEmpty()) {
            return null;
        }
        return dataList.get(0);
    }

    /**
     * 查询多条数据
     *
     * @param criteria 查询起始位置
     * @return 对象列表
     */
    @Override
    public List<ContainerTaskHis> findByCriteria(Criteria criteria) {
        return containerTaskHisMapper.findByCriteria(criteria);
    }

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    @Override
    public ContainerTaskHis findById(int id) {
        return containerTaskHisMapper.findById(id, ContainerTaskHis.class);
    }

    /**
     * 修改数据
     *
     * @param containerTaskHis 实例对象
     */
    @Override
    public long update(ContainerTaskHis containerTaskHis) {
        return containerTaskHisMapper.update(containerTaskHis);
    }

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     */
    @Override
    public long deleteById(int id) {
        return containerTaskHisMapper.deleteById(id, ContainerTaskHis.class);
    }

    /**
     * 通过参数删除数据
     *
     * @param paramMap 参数
     */
    @Override
    public long deleteByMap(Map<String, Object> paramMap) {
        return containerTaskHisMapper.deleteByMap(paramMap, ContainerTaskHis.class);
    }

    /**
     * 通过参数查询总条数
     *
     * @param paramMap 参数
     */
    @Override
    public long findCountByMap(Map<String, Object> paramMap) {
        return containerTaskHisMapper.findCountByMap(paramMap, ContainerTaskHis.class);
    }
}
